# 
# $Header: oracle.mk.pp,v 6.58 89/10/16 19:11:38 rafsarif Exp $ oracle.mk.pp Copyr (c) 1986 Oracle
# 

#
# oracle.mk - "make" command file to reload 'oracle'.
#
# Used to reload oracle after changing the SGA base address or adding a
# new network driver.
#
# The base address of the sga is specified by the symbol "sgabeg"
# or the symbol "sgadef" in the file ksms.s
#

KSMS=ksms.o
OTHERLIBS=`cat $(ORACLE_HOME)/rdbms/lib/sysliblist`
CLIBS=$(OTHERLIBS)
ECHO=$(ORACLE_HOME)/bin/echodo

ARREPLACE=ar r

LIBPLS=libpls.a

LIBKNL=libknl.a
LIBORA=libora.a $(LIBKNL) libora.a

LIBORAST=libora.a $(LIBPLS) $(LIBKNL) libora.a $(LIBPLS) $(LIBKNL)

CLIBS= -lld $(OTHERLIBS)

NETLIBS=osntab.o libsqlnet.a
OSNTABST=osntabst.o
CONFIG=config.o
STLIBS=libupi.a $(OSNTABST) libosn.a libsosd.a $(CONFIG)

default: oracle

oracle: $(LIBORA) $(NETLIBS) $(KSMS) $(CONFIG) $(LIBPLS) opimai.o
	@$(ECHO) $(CC) -o $@ $(LDFLAGS) opimai.o $(NETLIBS) $(CONFIG) \
	$(LIBORA) $(LIBPLS) $(LIBORA) $(LIBPLS) $(CLIBS)

sqldba: libsqldba.a $(LIBORA) $(NETLIBS) libtma.a
	@$(ECHO) $(CC) -o $@ $(LDFLAGS) libsqldba.a $(NETLIBS) libtma.a \
	$(LIBORA) $(CLIBS) 

exp: libexp.a $(LIBORA) $(NETLIBS)
	@$(ECHO) $(CC) -o $@ $(LDFLAGS) libexp.a $(NETLIBS) $(LIBORA) $(CLIBS)

imp: libimp.a $(LIBORA) $(NETLIBS)
	@$(ECHO) $(CC) -o $@ $(LDFLAGS) libimp.a $(NETLIBS) $(LIBORA) $(CLIBS)

odl: libodl.a $(LIBORA) $(NETLIBS)
	@$(ECHO) $(CC) -o $@ $(LDFLAGS) libodl.a $(NETLIBS) $(LIBORA) $(CLIBS)

expst: libexp.a $(LIBORAST) $(OSNTABST) $(CONFIG)
	@$(ECHO) $(CC) -o $@ $(LDFLAGS) libexp.a $(OSNTABST) $(CONFIG) \
	$(LIBORAST) $(CLIBS)

impst: libimp.a $(LIBORAST) $(OSNTABST) $(CONFIG) 
	@$(ECHO) $(CC) -o $@ $(LDFLAGS) libimp.a $(OSNTABST) $(CONFIG) \
	$(LIBORAST) $(CLIBS)

sqldbast: libsqldba.a $(LIBORAST) $(OSNTABST) $(CONFIG) libtma.a
	@$(ECHO) $(CC) -o $@ $(LDFLAGS) libsqldba.a $(OSNTABST) $(CONFIG) \
	libtma.a $(LIBORAST) $(CLIBS)

odlst: libodl.a $(LIBORAST) $(LIBKNL) $(OSNTABST) $(CONFIG)
	@$(ECHO) $(CC) -o $@ $(LDFLAGS) libodl.a $(OSNTABST) $(CONFIG) \
	$(LIBORAST) $(CLIBS)

install: oracle exp imp sqldba odl $(SPEC_TARGS)
	-chmod 755 $(ORACLE_HOME)/bin
	-mv -f $(ORACLE_HOME)/bin/oracle $(ORACLE_HOME)/bin/oracleO
	-mv -f $(ORACLE_HOME)/bin/exp $(ORACLE_HOME)/bin/expO
	-mv -f $(ORACLE_HOME)/bin/imp $(ORACLE_HOME)/bin/impO
	-mv -f $(ORACLE_HOME)/bin/sqldba $(ORACLE_HOME)/bin/sqldbaO
	-mv -f $(ORACLE_HOME)/bin/odl $(ORACLE_HOME)/bin/odlO
	-mv oracle $(ORACLE_HOME)/bin/oracle
	-mv exp $(ORACLE_HOME)/bin/exp
	-mv imp $(ORACLE_HOME)/bin/imp
	-mv sqldba $(ORACLE_HOME)/bin/sqldba
	-mv odl $(ORACLE_HOME)/bin/odl
	-chmod 4751 $(ORACLE_HOME)/bin/oracle
	-chmod 751 $(ORACLE_HOME)/bin/sqldba
	-chmod 751 $(ORACLE_HOME)/bin/exp
	-chmod 751 $(ORACLE_HOME)/bin/imp
	-chmod 751 $(ORACLE_HOME)/bin/odl

singletask: expst impst sqldbast odlst
	-chmod 755 $(ORACLE_HOME)/bin
	-mv -f $(ORACLE_HOME)/bin/expst $(ORACLE_HOME)/bin/expstO
	-mv -f $(ORACLE_HOME)/bin/impst $(ORACLE_HOME)/bin/impstO
	-mv -f $(ORACLE_HOME)/bin/sqldbast $(ORACLE_HOME)/bin/sqldbastO
	-mv -f $(ORACLE_HOME)/bin/odlst $(ORACLE_HOME)/bin/odlstO
	-mv expst $(ORACLE_HOME)/bin/expst
	-mv impst $(ORACLE_HOME)/bin/impst
	-mv sqldbast $(ORACLE_HOME)/bin/sqldbast
	-mv odlst $(ORACLE_HOME)/bin/odlst
	-chmod 751 $(ORACLE_HOME)/bin/sqldbast
	-chmod 751 $(ORACLE_HOME)/bin/expst
	-chmod 751 $(ORACLE_HOME)/bin/impst
	-chmod 751 $(ORACLE_HOME)/bin/odlst

$(LIBKNL): ksms.o
	chmod 644 $(LIBKNL)
	$(ARREPLACE) $(LIBKNL) ksms.o $(RANLIBORA)

osntab.c:
	$(ORACLE_HOME)/bin/genosntab -c $(GENARGS) > osntab.c

osntab.o: osntab.c
	$(CC) $(CFLAGS) -c osntab.c

osntabst.c: osntab.c
	-rm -f osntabst.c
	ln osntab.c osntabst.c

osntabst.o: osntabst.c
	$(CC) $(CFLAGS) -c -DSYS_SGL osntabst.c

$(CONFIG): config.c
	$(CC) $(CFLAGS) -c config.c

ksms.s:
	$(ORACLE_HOME)/bin/genksms > ksms.s

.PRECIOUS: $(LIBORA)
